# std::__profile::deque< _Tp, _Allocator > Class Template Reference

Class std::deque wrapper with performance instrumentation. More...

Inherits deque< _Tp, _Allocator >.

List of all members.

## Public Types

- typedef _Allocator allocator_type
- typedef _Base::const_iterator const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef
  _Base::const_reverse_iterator const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef _Base::iterator iterator
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef _Base::reverse_iterator reverse_iterator
- typedef _Base::size_type size_type
- typedef _Tp value_type

## Public Member Functions

- deque (const _Allocator &__a=_Allocator())
- deque (size_type __n, const _Tp &__value=_Tp(), const _Allocator &__a=_Allocator())
- deque (const deque &__x)
- deque (const _Base &__x)
- template<class _InputIterator > deque (_InputIterator __first, _InputIterator __last, const _Allocator &__a=_Allocator())
- deque (deque &&__x)
- deque (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
- _Base & _M_base ()
- const _Base & _M_base () const
- void assign (size_type __n, const _Tp &__t)
- template<class _InputIterator > void assign (_InputIterator __first, _InputIterator __last)
- void assign (initializer_list< value_type > __l)
- reference back ()
- const_reference back () const
- const_iterator begin () const
- iterator begin ()
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- const_reverse_iterator crbegin () const
- const_reverse_iterator crend () const
- template<typename... _Args> iterator emplace (iterator __position, _Args &&...__args)
- template<typename... _Args> void emplace_back (_Args &&...__args)
- template<typename... _Args> void emplace_front (_Args &&...__args)
- iterator end ()
- const_iterator end () const
- iterator erase (iterator __position)
- iterator erase (iterator __first, iterator __last)
- const_reference front () const
- reference front ()
- void insert (iterator __p, initializer_list< value_type > __l)
- iterator insert (iterator __position, const _Tp &__x)
- iterator insert (iterator __position, _Tp &&__x)
- void insert (iterator __position, size_type __n, const _Tp &__x)
- template<class _InputIterator > void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- deque & operator= (deque &&__x)
- deque & operator= (const deque &__x)
- deque & operator= (initializer_list< value_type > __l)
- const_reference operator[] (size_type __n) const
- reference operator[] (size_type __n)
- void pop_back ()
- void pop_front ()
- void push_back (const _Tp &__x)
- void push_back (_Tp &&__x)
- void push_front (const _Tp &__x)
- void push_front (_Tp &&__x)
- reverse_iterator rbegin ()
- const_reverse_iterator rbegin () const
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void resize (size_type __sz, _Tp __c=_Tp())
- void swap (deque &__x)

## Detailed Description

### template<typename _Tp, typename _Allocator = std::allocator<_Tp>>
class std::__profile::deque< _Tp, _Allocator >

Class std::deque wrapper with performance instrumentation.

Definition at line 40 of file profile/deque.

The documentation for this class was generated from the following file:

- profile/deque